/** 
 @file events.js
 
 @brief This file contain implementation of the event handling from the upnp ui.

 @author: mobile2DS

 @date: 15.12.2013
*/

var lWarn = {logln:function (o){}}; 
var lInfo = {logln:function (o){}};

var LOGFILE_NAME = "sonos-controller.log";
lWarn = new Logger(LOGFILE_NAME);
lInfo = new Logger(LOGFILE_NAME);

function getPlayersToExecUndo(oActvity) {
  var arrayPlayers = new Array();
  if (oActvity != null) {
    if (JSON.parse(oActvity.getChild('allRooms').getValue())) {// all players
       var baseNode = Property.getNode('sonos-players');
       if (baseNode != null) {
         var oArrayNode = baseNode.getChildren();
         for ( var iIndex = 0; iIndex < oArrayNode.length; iIndex++) {
           arrayPlayers.push(new Object({id:oArrayNode[iIndex].getChild('id').getValue(),
                                         device:oArrayNode[iIndex].getChild('deviceID').getValue(),
                                         playerIP:oArrayNode[iIndex].getChild('ipAddress').getValue()
                                        }));
         }
       }
    }
    else {
      // only selected players/rooms
      var baseNode = oActvity.getChild('pickedRooms');
      if (baseNode != null) {
        var rooms = unescape(baseNode.getChild('pickedRooms').getValue()).split(";");
        var oArrayNode = Property.getNode('sonos-players').getChildren();
        for ( var iIndex = 0; iIndex < oArrayNode.length; iIndex++) {
          if (rooms.indexOf(oArrayNode[iIndex].getChild('roomID').getValue())>-1)
            arrayPlayers.push(new Object({id:oArrayNode[iIndex].getChild('id').getValue(),
                                          device:oArrayNode[iIndex].getChild('deviceID').getValue(),
                                          playerIP:oArrayNode[iIndex].getChild('ipAddress').getValue()}));
        }
      }
    }
  }
  return arrayPlayers;
}


/* ---------------------------------------------------------------------------
                        EVENT handling
*/
if (raisedEvent.name === 'running') {
     lInfo.logln("running sonos events.js");
}
else if (raisedEvent.name === 'undoScene') {
  try {    
/*   
    var curl_options = new Object({'debug' : 1, 'connectTimeout' : 200});  
    upnpStop("192.168.1.108", curl_options)
var end = new Date().getTime();
var time = end - start;
lInfo.logln("Execution time: " + time);    
lInfo.logln("Execution timeF: " + (end - startA));    
*/
    lInfo.logln("undoScene zoneID/groupID/sceneID:  " +  raisedEvent.source.zoneID +" / " +raisedEvent.source.groupID+ " / "+ raisedEvent.parameter.sceneID);

    var nGroupID =  parseInt("" + raisedEvent.source.groupID, 10);
    var nSceneID =  parseInt("" + raisedEvent.parameter.sceneID, 10);
    var curl_options = new Object({'debug' : 1,'connectTimeout' : 200 });    
    
    if (nGroupID == 0 && predefinedUnduEvents.indexOf(nSceneID) > -1) {
      //var baseNode = Property.getNode('sonos-alarms');
      var restartData = null;
      
      // find sceneID in activities
      var arrayPlayers = null;
      var baseNode = Property.getNode('sonos-activities');
      if (baseNode != null) {
        var oArrayNode = baseNode.getChildren();
        var bFound = false;
        for ( var iIndex = 0; iIndex < oArrayNode.length; iIndex++) {
          var oChildNode = oArrayNode[iIndex];
lInfo.logln("Activity ID="+ oChildNode.getChild('id').getValue());
          var oTriggers = oChildNode.getChild('triggers').getChildren();
          if (oTriggers != null) {
            for ( var yIndex = 0; yIndex < oTriggers.length; yIndex++) {
              var oChildTrigger = oTriggers[yIndex];
lInfo.logln("Trigger type="+ oChildTrigger.getChild('type').getValue());
              switch(nSceneID) {
                case 76: // fire trigger does not store sceneID
                   if (oChildTrigger.getChild('name') != null && oChildTrigger.getChild('state') != null &&
                       oChildTrigger.getChild('name').getValue() == 'fire' && oChildTrigger.getChild('state').getValue() == 'active') {
                     arrayPlayers = getPlayersToExecUndo(oChildNode);
                     bFound = true;
                     break;
                   }
                break;

                default:
                   if (oChildTrigger.getChild('scene') != null && oChildTrigger.getChild('scene').getValue() == nSceneID) {
                     arrayPlayers = getPlayersToExecUndo(oChildNode);
                     bFound = true;
                     break;
                   }
                break;               
              }
            }
            if (bFound)
              break;
          }
        }
      }
      
      lInfo.logln(">>>>>>>UNDU ExecPlayers:"+JSON.stringify(arrayPlayers));             
      
      if (arrayPlayers != null && arrayPlayers.length > 0) {
        for (var iIndex=0;iIndex<arrayPlayers.length;iIndex++) {
          var playerID = arrayPlayers[iIndex].id;
          var unduData = handleUndoActivity(playerID,0,nSceneID);
          if (unduData != null) {
            var restartData = unduData.restoreData; 
        lInfo.logln("Undu restart data:"+JSON.stringify(restartData));             
            if (restartData != null) {
              if (restartData.activeQueueID != "") {
                // loadingOldQueue
                var aTmp = restartData.activeQueueID.split(':');
                if (aTmp != null && aTmp.length==2) {
                  var sQueueNr = aTmp[1];
                  upnpClearQueue(restartData.playerIP, curl_options);
                  upnpLoadPlaylist(restartData.playerIP, "file:///jffs/settings/savedqueues.rsq#"+sQueueNr, curl_options);                    
                }
                lInfo.logln("Deleting tmp queue");  
                upnpDeleteQueueFromList(restartData.playerIP, restartData.activeQueueID, curl_options);
              }
             
              if (restartData.volumeReset) {
                upnpSetVolume(restartData.playerIP, restartData.volumeDef, curl_options);
              }
              upnpSetPlayMode(restartData.playerIP, restartData.playMode, curl_options);

              if (!restartData.isRadio) {
    lInfo.logln("Undu Restarting music:"+restartData.playerIP+"/x-rincon-queue:"+arrayPlayers[iIndex].device+"#0"+"/"+restartData.activeAction); 
               // activating queue
                upnpSetContentSrc(restartData.playerIP, "x-rincon-queue:"+arrayPlayers[iIndex].device+"#0", curl_options);
                upnpSeek(restartData.playerIP, true, restartData.trackListPos, curl_options);
                upnpSeek(restartData.playerIP, false, restartData.trackPlayPos, curl_options);
                if (restartData.activeAction == "PLAYING")
                  upnpPlay(restartData.playerIP, curl_options);
              } 
              else {
    lInfo.logln("Undu  Restarting radio:"+restartData.playUrl+"/"+restartData.activeAction); 
                upnpStop(restartData.playerIP, curl_options);
                upnpSetRadio(restartData.playerIP, restartData.playUrl, "Radio", curl_options);
                if (restartData.activeAction == "PLAYING")
                  upnpPlay(restartData.playerIP, curl_options);
              }
            }
            else {
              if (unduData.performStop) {
                lInfo.logln("No sonos player undu, stop event music");
                upnpStop(arrayPlayers[iIndex].playerIP, curl_options);
              }
            }
          }
        }
      }
    }
  }
  catch (e) {
        lInfo.logln("Error by undoScene: " + e);
        for ( var i in e) {
            lInfo.logln(i + ': ' + e[i]);
        }                        
  }    
  
}
