Ext.define('DSS.addon.SetVolume', {
    extend : 'DSS.component.Base',
    mixins : {
        observable : 'Ext.util.Observable'
    },
    checkVolume:null,
    timeSpanVolume:null,
    constructor : function() {
        this.checkVolume = Ext.create('Ext.form.field.Checkbox', {
                                         fieldLabel : "",
                                         align : 'middle',
                                       });

         var lblSetVolume  = Ext.create('Ext.form.Label',{
               text : _("Set volume to"),
               align : 'middle',
               cls : 'x-form-item-label',
               margin : '0 0 0 10'
         }); 
          
         this.timeSpanVolume  = Ext.create('Ext.form.field.Number', {
               fieldLabel : "",
               margin : '0 0 0 10',
               width : 50,
               step : 1,
               value : 0,
               minValue : 0,
               maxValue : 100
          });
          
         var lblSetVolume2  = Ext.create('Ext.form.Label',{
               text : "%",
               align : 'middle',
               cls : 'x-form-item-label',
               margin : '0 0 0 4'
          }); 
          
          var rowVolume = Ext.create('Ext.container.Container', {
               defaultType : 'numberfield',
               items : [this.checkVolume, lblSetVolume, this.timeSpanVolume, lblSetVolume2],
               layout : 'column',
               margin : '2 0 5 0',
               width : 530
           });
           
           Ext.apply(this, { items : [ rowVolume ] });
           this.callParent(arguments);
        },
    reset: function (){
            this.checkVolume.setValue(false);
            this.timeSpanVolume.setValue(0);
    },
    setValue:function (value) {
            var nSelectedPresetID = this.dssEditor.editControls.id.getValue();
         
            var sString = dss.ajaxSyncRequest('/json/property/query', {
                 'query' : '/scripts/sonos-controller/sonos-presets/'+nSelectedPresetID+'(*)'
             });
            var result = Ext.JSON.decode(sString);
            var arrayVolume = dss.parsePropertyQueryAnswer(result,[{name:'volumeSet', type:'simple'},
                                                                   {name:'volume', type:'simple'}]); 
         
            this.checkVolume.setValue(false);
            this.timeSpanVolume.setValue(0);
            if (arrayVolume != null && JSON.parse(arrayVolume[0].volumeSet)) {
              this.checkVolume.setValue(true);
              this.timeSpanVolume.setValue(arrayVolume[0].volume);
            }
        },
        isValid:function(){
            return true;
        },
        getValue : function(){
          var returnValue = new Object();
          
          returnValue.setVolume = this.checkVolume.checked;
          returnValue.volume = this.timeSpanVolume.getValue(); 
          
          return returnValue;
        }
});

Ext.define('DSS.addon.SelectPreset', {
    extend : 'DSS.component.Base',
    mixins : {
        observable : 'Ext.util.Observable'
    },
    getHeight:function () {
                 return this.iDefaultHeight;
    },
    
    height : '100%',
    grids : {},
    selectedRoomID : -1,
    presetID : -1,
    macPanel : null,
    arrayAllPresets:null,
    iDefaultWidth : 150,
    iDefaultHeight : 332,
    defMacGridRenderer : function(val, metadata, record, colIdx, store, view) {
       var fIsPassive=false;        
       if (record.get('passive')!=null)
         if (record.get('passive'))
           fIsPassive=true;
        var fHasNext=false;
        if (record.get('next') == true)  {
            fHasNext=true;
        }
        var fHasIcon=false;
        if (record.get('icon') != null) {
            fHasIcon=true;
        }        
           
       var sReturn='<table style="height:16px;"><tr>';
       var iColspaceCounter=3;
       if (fHasIcon) {
            iColspaceCounter--;  
            sReturn+='<td><img src="' + record.get('icon') + '" style="margin-right: 5px;"></td>';
        }
       if (fIsPassive) {
            sReturn+='<td style="color:#888888;" colspan="'+iColspaceCounter+'" width="100%">' + record.get('name') + '</td>';
       } 
       else {
            sReturn+='<td colspan="'+iColspaceCounter+'" width="100%">' + record.get('name') + '</td>';
       }
       if (fHasNext) {
            sReturn+='<td>&gt;</td>';
       }
       
       return sReturn +'</tr></table>';      
    },
    initStores : function(bLoadAllPresetRooms) {
       //if (Ext.data.StoreManager.lookup('selectpreset_l1') == null) 
       {
         var sString = dss.ajaxSyncRequest('/json/property/query', {
            'query' : '/scripts/sonos-controller/sonos-players/*(*)/*(*)/*(*)/*(*)'
             });
         var result = Ext.JSON.decode(sString);
         this.arrayActiveRooms = dss.parsePropertyQueryAnswer(result,[{name:'id', type:'simple'},
                                                                      {name:'sonosRoom', type:'simple'}, 
                                                                      {name:'ipAddress', type:'simple'},
                                                                      {name:'roomID',type:'simple'}]);    
         var actions = new Array();
         var arrayRooms = new Array();
         for ( var iIndex = 0; iIndex < this.arrayActiveRooms.length; iIndex++) {
           if (this.arrayActiveRooms[iIndex].roomID >0) {
             for ( var yIndex = 0; yIndex < dss.staticDataModel.nameCache.length; yIndex++) {
               if (this.arrayActiveRooms[iIndex].roomID == dss.staticDataModel.nameCache[yIndex].ZoneID) {  
                 actions.push(new Object({name: dss.staticDataModel.nameCache[yIndex].name,
                                          _id : parseInt("" + dss.staticDataModel.nameCache[yIndex].ZoneID),
                                          icon: null, passive:false, next: true
                                        }));
                 arrayRooms.push(dss.staticDataModel.nameCache[yIndex].ZoneID);
               }
             } 
           }
         }

         sString = dss.ajaxSyncRequest('/json/property/query', {
                                          'query' : '/scripts/sonos-controller/sonos-presets/*(*)'
                                          });
         result = Ext.JSON.decode(sString);
         this.arrayAllPresets = dss.parsePropertyQueryAnswer(result,[{name:'roomID',type:'simple'},
                                                                {name:'presetID', type:'simple'}]); 
         
         if (bLoadAllPresetRooms) {
           // adding rooms that are still stored in presets and not anymore have assigned players
           if (this.arrayAllPresets != null) {
             for ( var iIndex = 0; iIndex < this.arrayAllPresets.length; iIndex++) {
               var nRoomID = parseInt("" + this.arrayAllPresets[iIndex].roomID, 10);
               if (nRoomID > 0 && arrayRooms.indexOf(nRoomID) == -1) {
                 for ( var yIndex = 0; yIndex < dss.staticDataModel.nameCache.length; yIndex++) {
                   if (nRoomID == dss.staticDataModel.nameCache[yIndex].ZoneID) {  
                       actions.push(new Object({name: dss.staticDataModel.nameCache[yIndex].name,
                                                _id : nRoomID,
                                                icon: null, passive:true, next: true
                                           }));
                        arrayRooms.push(nRoomID);
                   }
                 } 
               }
             }
           }
         }
        
         Ext.create('Ext.data.Store', {
             storeId : 'selectpreset_l1',
             fields : [ '_id', 'name', 'next', 'icon' ,'passive'],
             proxy : {
                 type : 'memory',
                 reader : {
                     type : 'json',
                     root : 'items'
                 }
             }
         });
         Ext.data.StoreManager.lookup('selectpreset_l1').add(actions);
       }
    },
    constructGridLvlPresets : function() {

        // for selected room test which preset are still available
        var arrayUsedPresets = new Array();
        if (this.selectedRoomID > 0 && this.arrayAllPresets != null) {
           for ( var iIndex = 0; iIndex < this.arrayAllPresets.length; iIndex++) {
             var nRoomID = parseInt("" + this.arrayAllPresets[iIndex].roomID, 10);
             var presetID = parseInt("" + this.arrayAllPresets[iIndex].presetID, 10);
             if (nRoomID == this.selectedRoomID && 
                 (this.presetID == -1 || (this.presetID>-1 && this.presetID != presetID)) // on edit we skip currently edited preset
                )
               arrayUsedPresets.push(presetID);
           }
        }
        
        if (Ext.data.StoreManager.lookup('selectpreset_list') != null) {
          Ext.data.StoreManager.lookup('selectpreset_list').removeAll();
        }
        else {
          Ext.create('Ext.data.Store', {
             storeId : 'selectpreset_list',
             fields : [ '_id', 'name', 'next', 'icon', 'passive' ],
             proxy : {
                 type : 'memory',
                 reader : {
                     type : 'json',
                     root : 'items'
                 }
             }
          });
        }
         
        var arrayPresets = new Array();
        arrayPresets.push(new Object({name: dss.staticDataModel.getNameForScene(this.selectedRoomID, 4, 17), _id : 17, icon: '/framework/images/groupIcons/group_4_active.png', passive:(arrayUsedPresets.indexOf(17)!=-1), next: false}));
        arrayPresets.push(new Object({name: dss.staticDataModel.getNameForScene(this.selectedRoomID, 4, 18), _id : 18, icon: '/framework/images/groupIcons/group_4_active.png', passive:(arrayUsedPresets.indexOf(18)!=-1), next: false}));
        arrayPresets.push(new Object({name: dss.staticDataModel.getNameForScene(this.selectedRoomID, 4, 19), _id : 19, icon: '/framework/images/groupIcons/group_4_active.png', passive:(arrayUsedPresets.indexOf(19)!=-1), next: false}));
        arrayPresets.push(new Object({name: dss.staticDataModel.getNameForScene(this.selectedRoomID, 4, 20), _id : 20, icon: '/framework/images/groupIcons/group_4_active.png', passive:(arrayUsedPresets.indexOf(20)!=-1), next: false}));
        arrayPresets.push(new Object({name: dss.staticDataModel.getNameForScene(this.selectedRoomID, 4, 21), _id : 21, icon: '/framework/images/groupIcons/group_4_active.png', passive:(arrayUsedPresets.indexOf(21)!=-1), next: false}));
        arrayPresets.push(new Object({name: dss.staticDataModel.getNameForScene(this.selectedRoomID, 4, 22), _id : 22, icon: '/framework/images/groupIcons/group_4_active.png', passive:(arrayUsedPresets.indexOf(22)!=-1), next: false}));
        arrayPresets.push(new Object({name: dss.staticDataModel.getNameForScene(this.selectedRoomID, 4, 23), _id : 23, icon: '/framework/images/groupIcons/group_4_active.png', passive:(arrayUsedPresets.indexOf(23)!=-1), next: false}));
        arrayPresets.push(new Object({name: dss.staticDataModel.getNameForScene(this.selectedRoomID, 4, 24), _id : 24, icon: '/framework/images/groupIcons/group_4_active.png', passive:(arrayUsedPresets.indexOf(24)!=-1), next: false}));
        arrayPresets.push(new Object({name: dss.staticDataModel.getNameForScene(this.selectedRoomID, 4, 25), _id : 25, icon: '/framework/images/groupIcons/group_4_active.png', passive:(arrayUsedPresets.indexOf(25)!=-1), next: false}));
        arrayPresets.push(new Object({name: dss.staticDataModel.getNameForScene(this.selectedRoomID, 4, 26), _id : 26, icon: '/framework/images/groupIcons/group_4_active.png', passive:(arrayUsedPresets.indexOf(26)!=-1), next: false}));
        arrayPresets.push(new Object({name: dss.staticDataModel.getNameForScene(this.selectedRoomID, 4, 27), _id : 27, icon: '/framework/images/groupIcons/group_4_active.png', passive:(arrayUsedPresets.indexOf(27)!=-1), next: false}));
        arrayPresets.push(new Object({name: dss.staticDataModel.getNameForScene(this.selectedRoomID, 4, 28), _id : 28, icon: '/framework/images/groupIcons/group_4_active.png', passive:(arrayUsedPresets.indexOf(28)!=-1), next: false}));
        arrayPresets.push(new Object({name: dss.staticDataModel.getNameForScene(this.selectedRoomID, 4, 29), _id : 29, icon: '/framework/images/groupIcons/group_4_active.png', passive:(arrayUsedPresets.indexOf(29)!=-1), next: false}));
        arrayPresets.push(new Object({name: dss.staticDataModel.getNameForScene(this.selectedRoomID, 4, 30), _id : 30, icon: '/framework/images/groupIcons/group_4_active.png', passive:(arrayUsedPresets.indexOf(30)!=-1), next: false}));
        arrayPresets.push(new Object({name: dss.staticDataModel.getNameForScene(this.selectedRoomID, 4, 31), _id : 31, icon: '/framework/images/groupIcons/group_4_active.png', passive:(arrayUsedPresets.indexOf(31)!=-1), next: false}));
   
        Ext.data.StoreManager.lookup('selectpreset_list').add(arrayPresets);                     
     
        this.grids.lvlPresets = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : 624,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            selModel : {
                mode : 'SINGLE'
            },
            store : Ext.data.StoreManager.lookup('selectpreset_list'),
            columns : [ {
                sortable : false,
                hideable : false,
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });

        this.grids.lvlPresets.parent = this;

        this.grids.lvlPresets.on('itemclick', function(grid, record) {
            if (record.get('passive')) {
                this.getSelectionModel().deselect(record);
            }           
        });
        this.macPanel.add(this.grids.lvlPresets);

    },
    constructMacGrids : function() {
      var me = this;
      this.grids.lvl1 = Ext.create('Ext.grid.Panel', {
          hideHeaders:true,
          height : this.iDefaultHeight,
          width : this.iDefaultWidth,
          autoScroll : true,
          viewConfig : {
              stripeRows : true
          },
          selModel : {
              mode : 'SINGLE'
          },
          columns : [ {
              sortable : false,
              hideable : false,
              dataIndex : 'name',
              flex : 1,
              renderer : this.defMacGridRenderer
          } ]
      });
      this.grids.lvl1.getSelectionModel().store = this.grids.lvl1.store;
      this.grids.lvl1.parent = this;

      this.grids.lvl1.on('itemclick', function(grid, record) {
          this.parent.macPanel.remove(this.parent.grids.lvlPresets);
          me.selectedRoomID = record.get('_id');
          this.parent.constructGridLvlPresets();
      }); 
    },
    constructor : function() {
        this.initStores(false);
        this.constructMacGrids();

        this.macPanel = Ext.create('Ext.panel.Panel', {
            border : '0',
            autoScroll : true,
            height : this.iDefaultHeight+2,
            layout : {
                type : 'hbox'
            },
            items : [ this.grids.lvl1 ],
            scroll : 'horizontal'
        });
        
        Ext.apply(this, {
            items : [ this.macPanel ]
        });

        this.callParent(arguments);
    },
    reset : function() {
      this.selectedRoomID = -1;
      this.presetID = -1;
      this.initStores(false);
      this.grids.lvl1.reconfigure(Ext.data.StoreManager.lookup('selectpreset_l1'));
      this.macPanel.remove(this.grids.lvlPresets); 
    },
    setValue : function(values) {
      this.initStores(true);
      this.grids.lvl1.reconfigure(Ext.data.StoreManager.lookup('selectpreset_l1'));
      this.macPanel.remove(this.grids.lvlPresets); 
      
      var nSelectedPresetID = this.dssEditor.editControls.id.getValue();
      if (nSelectedPresetID != null) {
        var sString = dss.ajaxSyncRequest('/json/property/query', {
                                          'query' : '/scripts/sonos-controller/sonos-presets/'+nSelectedPresetID+'(*)'
                                          });
        var result = Ext.JSON.decode(sString);
        var arrayPreset = dss.parsePropertyQueryAnswer(result,[{name:'roomID',type:'simple'},
                                                               {name:'presetID', type:'simple'}]); 
        if (arrayPreset != null) {
          var store = this.grids.lvl1.getStore();
          var foundRec = store.getAt(store.findExact('_id', parseInt("" + arrayPreset[0].roomID,10)));
          this.grids.lvl1.getSelectionModel().select(foundRec);   
         
          this.selectedRoomID = arrayPreset[0].roomID;
          this.presetID = arrayPreset[0].presetID;
          this.constructGridLvlPresets();
          var oRecordZone2 = this.grids.lvlPresets.store.find('_id', arrayPreset[0].presetID, 0, false,false,true);
          if (oRecordZone2 != -1)
            this.grids.lvlPresets.getSelectionModel().select(oRecordZone2);
        }
      }
    },
    isValid : function() {
       var bValid = false;
     
       var oSelectionLVL1 = this.grids.lvl1.getSelectionModel().getSelection();
       if (this.grids.lvlPresets != null) {
         var oSelectionPreset = this.grids.lvlPresets.getSelectionModel().getSelection();
         if (oSelectionLVL1[0] != null && oSelectionPreset[0] != null)
           bValid = true;
       }
       return bValid;
    },
    getValue : function() {
      var returnValue = new Object();
      try {
        var oSelectionLVL1 = this.grids.lvl1.getSelectionModel().getSelection();
        if (this.grids.lvlPresets != null) {
          var oSelectionPlaylist = this.grids.lvlPresets.getSelectionModel().getSelection();
          returnValue.roomID = oSelectionLVL1[0].get('_id');
          returnValue.presetID = oSelectionPlaylist[0].get('_id');
          returnValue.presetName = oSelectionPlaylist[0].get('name');
        }
      }
      catch (e){}
      return returnValue;
    }    
});

Ext.define('DSS.addon.WhatToPlay', {
    extend : 'DSS.component.Base',
    mixins : {
        observable : 'Ext.util.Observable'
    },
    getHeight:function () {
       return this.iDefaultHeight;
    },

    height : '100%',
    grids : {'preset': {},
             'activity': {} 
            },
    nowFileType:-1, // -1: nothing, 0: current music, 1: current queue
    parentDialog:'',
    checkVolume:null,
    timeSpanVolume:null,
    checkRepeat:null,
    timeSpanRepeat:null,
    checkRestart:null,
    checkGrouping:null,
    lblNowPlayed:null,
    selectedSong:null,
    selectedQueue:null,
    dialogPreset: false,
    gridQueue:null,
    macPanel : null,
    arrayActiveRooms : null,
    nSelectedRoom : null,
    sSelectedRoomIP : "",
    iDefaultWidth : 150,
    iDefaultHeight : 290,
    defMacGridRenderer : function(val, metadata, record, colIdx, store, view) {
       var fIsPassive=false;        
       if (record.get('passive')!=null)
         if (record.get('passive'))
           fIsPassive=true;
        var fHasNext=false;
        if (record.get('next') == true)  {
            fHasNext=true;
        }
           
       var sReturn='<table style="height:16px;"><tr>';
       var iColspaceCounter=3;
       if (fIsPassive) {
            sReturn+='<td style="color:#888888;" colspan="'+iColspaceCounter+'" width="100%">' + record.get('name') + '</td>';
       } 
       else {
            sReturn+='<td colspan="'+iColspaceCounter+'" width="100%">' + record.get('name') + '</td>';
       }
       if (fHasNext) {
            sReturn+='<td>&gt;</td>';
       }
       
       return sReturn +'</tr></table>';      
    },
    initStores : function() {
try{     
       if (Ext.data.StoreManager.lookup('whattoplay_l1Store_'+this.parentDialog) == null) {
         var actions =[{ name : _('Now Playing'),
                         _id : 0,
                         next : true,
                         icon : null,
                         passive: false
                       }, {
                           name : _('Sonos Playlist'),
                           _id : 1,
                           next : true,
                           icon : null,
                           passive: false
                       }, {
                           name : _('Sonos Favorites'),
                           _id : 2,
                           next : true,
                           icon : null,
                           passive: false
                       }];
            if (!this.dialogPreset) {
              actions.push({name : _('Library'),
                            _id : 3,
                            next : true,
                            icon : null,
                            passive: true
                          });
              actions.push({name : _('Text to speech'),
                            _id : 4,
                            next : true,
                            icon : null,
                            passive: true
                           });
              actions.push({name : _("Command"),
                            _id : 5,
                            next : true,
                            icon : null,
                            passive:false
                           });
            }
                       
            Ext.create('Ext.data.Store', {
                storeId : 'whattoplay_l1Store_'+this.parentDialog,
                fields : [ '_id', 'name', 'next', 'icon' ,'passive'],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            Ext.data.StoreManager.lookup('whattoplay_l1Store_'+this.parentDialog).add(actions);
       }
       //if (Ext.data.StoreManager.lookup('whattoplay_playlists') == null) 
         var sString = dss.ajaxSyncRequest('/json/property/query', {
             'query' : '/scripts/sonos-controller/sonos-playlists/*(*)/*(*)/*(*)/*(*)'
         });
         var result = Ext.JSON.decode(sString);
         var arrayData=dss.parsePropertyQueryAnswer(result,[{name:'title', type:'simple'},
                                                            {name:'listURL', type:'simple'},
                                                            {name:'playListSonosID', type:'simple'}
                                                                 ]);    
         Ext.create('Ext.data.Store', {
             storeId : 'whattoplay_playlists',
             fields : [ '_id', 'name', 'next', 'icon', 'listUrl' ],
             proxy : {
                 type : 'memory',
                 reader : {
                     type : 'json',
                     root : 'items'
                 }
             }
         });
         
         for (var i=0;i<arrayData.length;i++) {
           arrayData[i].name = unescape(arrayData[i].title);
           arrayData[i]._id = unescape(arrayData[i].playListSonosID);
           arrayData[i].listUrl = unescape(arrayData[i].listURL);
           arrayData[i].next = false;
           arrayData[i].icon = null;
         }                                           
         Ext.data.StoreManager.lookup('whattoplay_playlists').add(arrayData);                     
       //if (Ext.data.StoreManager.lookup('whattoplay_favorites') == null) 

         var sString = dss.ajaxSyncRequest('/json/property/query', {
             'query' : '/scripts/sonos-controller/sonos-favorites/*(*)/*(*)/*(*)/*(*)'
         });
         var result = Ext.JSON.decode(sString);
         var arrayData = dss.parsePropertyQueryAnswer(result,[{name:'title', type:'simple'},
                                                                 {name:'description', type:'simple'},
                                                                 {name:'listURL', type:'simple'},
                                                                 {name:'playListSonosID', type:'simple'}
                                                                 ]);    
         Ext.create('Ext.data.Store', {
             storeId : 'whattoplay_favorites',
             fields : [ '_id', 'name', 'next', 'icon', 'listUrl' ],
             proxy : {
                 type : 'memory',
                 reader : {
                     type : 'json',
                     root : 'items'
                 }
             }
         });
         
         for (var i=0;i<arrayData.length;i++) {
           arrayData[i].name = unescape(arrayData[i].title);
           if (arrayData[i].description.length > 0)
             arrayData[i].name += " (" +unescape(arrayData[i].description)+ ")"; 
           arrayData[i]._id = unescape(arrayData[i].playListSonosID);
           arrayData[i].listUrl = unescape(arrayData[i].listURL);
           arrayData[i].next = false;
           arrayData[i].icon = null;
         }                                           
         Ext.data.StoreManager.lookup('whattoplay_favorites').add(arrayData);                     
       if (Ext.data.StoreManager.lookup('whattoplay_commands') == null) {
                                   
         Ext.create('Ext.data.Store', {
             storeId : 'whattoplay_commands',
             fields : [ '_id', 'name', 'next', 'icon', 'passive' ],
             proxy : {
                 type : 'memory',
                 reader : {
                     type : 'json',
                     root : 'items'
                 }
             }
         });

         var arrayCommands = new Array({name : _('Stop'),
                                         _id : 1,
                                         next : false,
                                         icon : null,
                                         passive: false
                                        },
                                        {name : _('Play'),
                                         _id : 2,
                                         next : false,
                                         icon : null,
                                         passive: false
                                        },
                                        {name : _('Pause'),
                                         _id : 3,
                                         next : false,
                                         icon : null,
                                         passive: false
                                        },
                                        {name : _('Mute'),
                                         _id : 4,
                                         next : false,
                                         icon : null,
                                         passive: false
                                        },
                                        {name : _('Unmute'),
                                         _id : 5,
                                         next : false,
                                         icon : null,
                                         passive: false
                                        });
         
         Ext.data.StoreManager.lookup('whattoplay_commands').add(arrayCommands);                     
       }
           
       var sString = dss.ajaxSyncRequest('/json/property/query', {
            'query' : '/scripts/sonos-controller/sonos-players/*(*)/*(*)/*(*)/*(*)'
        });
       var result = Ext.JSON.decode(sString);
       var arrayTmp = dss.parsePropertyQueryAnswer(result,[{name:'id', type:'simple'},
                                                           {name:'sonosRoom', type:'simple'}, 
                                                           {name:'ipAddress', type:'simple'},
                                                           {name:'roomID',type:'simple'}]);    
      
       this.arrayActiveRooms = [];
       var arrayPlayRooms = new Array();
       for ( var iIndex = 0; iIndex < arrayTmp.length; iIndex++) {
         var roomID = parseInt("" + arrayTmp[iIndex].roomID, 10); 
         if (roomID > 0) {
           for ( var yIndex = 0; yIndex < dss.staticDataModel.nameCache.length; yIndex++) {
             if (dss.staticDataModel.nameCache[yIndex].ZoneID == roomID) { 
               arrayTmp[iIndex].roomName = dss.staticDataModel.nameCache[yIndex].name;
               arrayTmp[iIndex].sonosRoom = unescape(arrayTmp[iIndex].sonosRoom);
               this.arrayActiveRooms.push(arrayTmp[iIndex]);

               var tmpData = new Object({'_id':arrayTmp[iIndex].id,
                                         'name':arrayTmp[iIndex].roomName,
                                         'next':true,
                                         'passive' : false,
                                         'playerIP' : arrayTmp[iIndex].ipAddress 
                                        });
               arrayPlayRooms.push(tmpData);
               break;
             }
           } 
         }
       }
       
       if (!this.dialogPreset) 
       {
         Ext.create('Ext.data.Store', {
             storeId : 'whattoplay_rooms',
             fields : [ '_id', 'name', 'next', 'icon', 'passive', 'playerIP'],
             proxy : {
                 type : 'memory',
                 reader : {
                     type : 'json',
                     root : 'items'
                 }
             }
         });
         Ext.create('Ext.data.Store', {
             storeId : 'whattoselect_rooms',
             fields : [ 'roomID', 'roomName', 'passive'],
             proxy : {
                 type : 'memory',
                 reader : {
                     type : 'json',
                     root : 'items'
                 }
             }
         });
         Ext.data.StoreManager.lookup('whattoplay_rooms').add(arrayPlayRooms);   
         Ext.data.StoreManager.lookup('whattoselect_rooms').add(this.arrayActiveRooms);   
       }
       this.constructActivityFields();
                                                               
       Ext.create('Ext.data.Store', {
             storeId : 'whattoplay_queue',
             fields : [ '_id', 'name', 'next', 'icon', 'passive' ],
             proxy : {
                 type : 'memory',
                 reader : {
                     type : 'json',
                     root : 'items'
                 }
             }
         });
} 
catch (e){
   alert("WtP initCache "+e.message);
}          
    },
    getSonosDeviceMusic : function () {
        var me = this;
        
        me.gridQueue.setVisible(false);
        me.lblNowPlayed.setVisible(true);
           
        if ((me.dialogPreset && me.nSelectedRoom > -1) ||
            (!me.dialogPreset)) {
               var waitDialog = new Ext.LoadMask(Ext.getBody(), {msg:_('Please wait, reading from Sonos device ...')});
               waitDialog.show();
              
               var sIP = "";
               if (me.dialogPreset) {
                 for ( var iIndex = 0; iIndex < me.arrayActiveRooms.length; iIndex++) {
                   if (me.arrayActiveRooms[iIndex].roomID == me.nSelectedRoom) {
                     sIP = me.arrayActiveRooms[iIndex].ipAddress;
                     break;
                   }
                 }
               }
               else {
                 sIP = me.sSelectedRoomIP;
               }
               
               dss.ajaxAssyncRequestWithoutAnswer('/json/event/raise',{name:'sonos-controller.getdata',
                                                                       parameter:'actions=getSonosTrack;value='+Ext.JSON.encode(sIP)});
               
               var iSubscriptID = Math.floor(Math.random() * 100000000000);
               dss.ajaxSyncRequest('/json/event/subscribe', {
                   subscriptionID : iSubscriptID,
                   name : 'sonos-discover-return-sonos-track'
               });

               dss.ajaxAssyncRequestWithoutAnswer('/json/event/get', {
                   subscriptionID : iSubscriptID,
                   timeout : 1*1000
               }, function(sValue) {
                   var oValue=JSON.parse(sValue);
                   var bWarnOnlySong = false;
                   if (oValue != null && oValue.result != null && oValue.result.events[0] != null && oValue.result.events[0].properties != null) {
                     me.selectedSong = JSON.parse(unescape(oValue.result.events[0].properties.returnValue));
                     var sTitle = _("No music");
                     if (me.selectedSong != null && 
                         me.selectedSong instanceof Object &&
                         me.selectedSong.title != "" && 
                         me.selectedSong.url != "") {
                       sTitle = _("Song: ");
                       if (me.selectedSong.isRadio)
                         sTitle = _("Radio: ");
                       
                       if (me.selectedSong.title != "")
                         sTitle += me.selectedSong.title;
                       if (me.selectedSong.artist != "")
                         sTitle += " ("+me.selectedSong.artist+")";
                       me.selectedSong.changed = true;
                     }
                     else
                       me.selectedSong = null;
                     me.lblNowPlayed.setText(sTitle); 
                     //me.grids.lvlNowPlaying.add(me.lblNowPlayed);

                     me.nowFileType = 0;
                   }
                   waitDialog.hide();
                   if (bWarnOnlySong)
                     Ext.MessageBox.alert(_('Info'), _("Only music with defined length allowed"), null);
                
                   dss.ajaxAssyncRequestWithoutAnswer('/json/event/unsubscribe', {
                       subscriptionID : iSubscriptID,
                       name : 'sonos-discover-return-sonos-track'
                   });
               });   
             }     
    },  
    getSonosDeviceQueue : function () {
       var me = this;
       
        me.gridQueue.setVisible(false);
        me.lblNowPlayed.setVisible(false);
       
       if ((me.dialogPreset && me.nSelectedRoom > -1) || (!me.dialogPreset)) {
        var waitDialog = new Ext.LoadMask(Ext.getBody(), {msg:_('Please wait, reading from Sonos device ...')});
        waitDialog.show();
       
        var sIP = "";
        if (me.dialogPreset) {
          for ( var iIndex = 0; iIndex < me.arrayActiveRooms.length; iIndex++) {
            if (me.arrayActiveRooms[iIndex].roomID == me.nSelectedRoom) {
              sIP = me.arrayActiveRooms[iIndex].ipAddress;
              break;
            }
          }
        }
        else {                                                             
          sIP = me.sSelectedRoomIP;
        }


        var sValue=dss.ajaxSyncRequest('/json/event/raise',{name:'sonos-controller.getdata',
                                                            parameter:'actions=getSonosQueue;value='+Ext.JSON.encode(sIP)});
        
        var iSubscriptID = Math.floor(Math.random() * 100000000000);
        dss.ajaxSyncRequest('/json/event/subscribe', {
            subscriptionID : iSubscriptID,
            name : 'sonos-discover-return-sonos-queue'
        });

        dss.ajaxAssyncRequestWithoutAnswer('/json/event/get', {
            subscriptionID : iSubscriptID,
            timeout : 5*1000
        }, function(sValue) {
            var oValue=JSON.parse(sValue);
            if (oValue != null && oValue.result != null && oValue.result.events[0] != null && oValue.result.events[0].properties != null) {
              me.selectedQueue = JSON.parse(unescape(oValue.result.events[0].properties.returnValue));
              if (me.selectedQueue != null) {
                Ext.data.StoreManager.lookup('whattoplay_queue').removeAll();
               
                if (me.selectedQueue.length > 0) {
                  var arrayFiles  = new Array();
                  for ( var iIndex = 0; iIndex < me.selectedQueue.length; iIndex++) {
                    var pos = (iIndex+1);
                    var tmpObj = new Object({_id:iIndex, 
                                             name:pos+". "+unescape(me.selectedQueue[iIndex].title)});
                    arrayFiles.push(tmpObj);
                  }
                  Ext.data.StoreManager.lookup('whattoplay_queue').add(arrayFiles);  
                  me.gridQueue.setVisible(true);
                  me.selectedQueue.changed = true;
                }
                else {
                  me.lblNowPlayed.setText(_("Active Queue is empty.")); 
                  me.lblNowPlayed.setVisible(true);
                }
                me.nowFileType = 1;
              }
            }
            waitDialog.hide();
         
            dss.ajaxAssyncRequestWithoutAnswer('/json/event/unsubscribe', {
                subscriptionID : iSubscriptID,
                name : 'sonos-discover-return-sonos-queue'
            });
        });                
      }
    },
    constructGridLvlNowPlaying : function() {
try{     
      var me = this;
       
      if (!this.dialogPreset )
      {
        this.grids[this.parentDialog].lvlNowRooms = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : me.iDefaultHeight,
            width : 160,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            selModel : {
                mode : 'SINGLE'
            },
            store : Ext.data.StoreManager.lookup('whattoplay_rooms'),
            columns : [ {
                sortable : false,
                hideable : false,
                dataIndex : 'name',
                flex : 1,
                renderer : me.defMacGridRenderer
            } ]
        });
        this.grids[this.parentDialog].lvlNowRooms.parent = this;
        this.macPanel.add(this.grids[this.parentDialog].lvlNowRooms);
      }

      this.lblNowPlayed = Ext.create('Ext.form.Label',{
                                          text : "",
                                          margin : '0 0 2 20',
                                          cls : 'x-form-item-label',
                                          id: 'lblNowPlayed'
                                       });
      this.lblNowPlayed.setVisible(false);
      
      this.gridQueue = Ext.create('Ext.grid.Panel', {
             hideHeaders:true,
             autoScroll : true,
             width:400,
             height:230,
             margin : '5 0 0 20',
             store : Ext.data.StoreManager.lookup('whattoplay_queue'),
             viewConfig : {
                 stripeRows : true
             },
             selModel : {
                 mode : 'NONE'
             },
             columns : [ {
                 sortable : false,
                 hideable : false,
                 flex : 1,
                 renderer : this.defMacGridRenderer
             } ]
         }); 
      this.gridQueue.setVisible(false);
      this.gridQueue.on('itemclick', function(grid, record) {
          this.getSelectionModel().deselect(record);
      });
      if (!this.dialogPreset)
        this.gridQueue.setHeight(160);
      else
        this.gridQueue.setHeight(230);
        
       
      var btnGet = Ext.create('Ext.Button', {
             text: 'Get song',
             margin : '0 0 2 20',
             handler: function() {
     
                if (me.dialogPreset) { 
                  me.nSelectedRoom = me.dssEditor.editControls.triggerPreset.selectedRoomID;
                  if (me.nSelectedRoom > -1)
                    me.getSonosDeviceMusic();  
                  else
                    Ext.MessageBox.alert(_('Info'), _("Please first select room on trigger tab, to get current Sonos song"), null);
                }
                else
                  me.getSonosDeviceMusic();
             }   
         });
      var btnQueue = Ext.create('Ext.Button', {
             text: 'Get Active queue',
             margin : '0 0 2 20',
             handler: function() {
                if (me.dialogPreset) { 
                  me.nSelectedRoom = me.dssEditor.editControls.triggerPreset.selectedRoomID;
                  if (me.nSelectedRoom > -1)
                    me.getSonosDeviceQueue();  
                  else
                    Ext.MessageBox.alert(_('Info'), _("Please first select room on trigger tab, to get current Sonos Queue"), null);
                }
                else
                  me.getSonosDeviceQueue();
             }
         });
      var allButtons = Ext.create('Ext.container.Container', {
            defaultType : 'numberfield',
            items : [  btnGet, btnQueue ],
            layout: {type: 'hbox'},
            margin : '5 0 5 0',
            width : 600 });

      this.grids[this.parentDialog].lvlNowPlaying = Ext.create('Ext.container.Container', {
            defaultType : 'numberfield',
            items : [ allButtons, me.lblNowPlayed, me.gridQueue ], 
            layout: {type: 'vbox'},
            margin : '5 0 5 0',
            width : 440
       });

                      
      if (!this.dialogPreset) {
        this.grids[this.parentDialog].lvlNowRooms.on('itemclick', function(grid, record) {
          var oSelectionFavorites = this.getSelectionModel().getSelection();
          me.nSelectedRoom = oSelectionFavorites[0].get('_id');  
          me.sSelectedRoomIP = oSelectionFavorites[0].get('playerIP');  
          me.macPanel.add(me.grids[me.parentDialog].lvlNowPlaying);
          
          me.lblNowPlayed.setVisible(false);
          me.lblNowPlayed.setText("");
          me.selectedSong = null;
          
          me.gridQueue.setVisible(false);
          me.selectedQueue = null;
        });
      }
      else  {
        //this.grids[this.parentDialog].lvlNowPlaying.setHeight(600);
        this.macPanel.add(this.grids[this.parentDialog].lvlNowPlaying);
      }
}        
catch (e){
//   alert("WtP initCache "+e.message);
}           
    },
    constructGridLvlPlaylist : function() {
        this.grids[this.parentDialog].lvlPlaylist = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : 624,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            selModel : {
                mode : 'SINGLE'
            },
            store : Ext.data.StoreManager.lookup('whattoplay_playlists'),
            columns : [ {
                sortable : false,
                hideable : false,
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });

        this.grids[this.parentDialog].lvlPlaylist.parent = this;

        this.grids[this.parentDialog].lvlPlaylist.on('itemclick', function(grid, record) {
            if (record.get('_id') == -1) {
                this.getSelectionModel().deselect(record);
            }           
        });
        this.macPanel.add(this.grids[this.parentDialog].lvlPlaylist);

    },
    constructGridLvlFavorites : function() {

        this.grids[this.parentDialog].lvlFavorites = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : 624,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            selModel : {
                mode : 'SINGLE'
            },
            store : Ext.data.StoreManager.lookup('whattoplay_favorites'),
            columns : [ {
                sortable : false,
                hideable : false,
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });

        this.grids[this.parentDialog].lvlFavorites.parent = this;

        this.grids[this.parentDialog].lvlFavorites.on('itemclick', function(grid, record) {
            if (record.get('_id') == -1) {
                this.getSelectionModel().deselect(record);
            }           
        });
        this.macPanel.add(this.grids[this.parentDialog].lvlFavorites);

    },
    constructGridLvlCommands : function() {

        this.grids[this.parentDialog].lvlCommands = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : 624,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            selModel : {
                mode : 'SINGLE'
            },
            store : Ext.data.StoreManager.lookup('whattoplay_commands'),
            columns : [ {
                sortable : false,
                hideable : false,
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });

        this.grids[this.parentDialog].lvlCommands.parent = this;

        this.grids[this.parentDialog].lvlCommands.on('itemclick', function(grid, record) {
            if (record.get('_id') == -1) {
                this.getSelectionModel().deselect(record);
            }           
        });
        this.macPanel.add(this.grids[this.parentDialog].lvlCommands);

    },
    constructActivityFields : function() {
       /* VOLUME */      
try {            
       var me = this;  
       var rowRepeat = null;  
       var rowRestart = null;
       var rowGrouping = null;               
       this.checkVolume = Ext.create('Ext.form.field.Checkbox', {
                                      fieldLabel : "",
                                      align : 'middle',
                                      listeners:{
                                        'change': function(checkbox, newVal, oldVal){
                                                   }
                                      }                                      
                                    });

       var lblSetVolume  = Ext.create('Ext.form.Label',{
            text : _("Set volume to"),
            align : 'middle',
            cls : 'x-form-item-label',
            margin : '0 0 0 10'
       }); 
       
       this.timeSpanVolume  = Ext.create('Ext.form.field.Number', {
            fieldLabel : "",
            margin : '0 0 0 10',
            width : 50,
            step : 1,
            value : 0,
            minValue : 0,
            maxValue : 100
       });
       
       var lblSetVolume2  = Ext.create('Ext.form.Label',{
            text : "%",
            align : 'middle',
            cls : 'x-form-item-label',
            margin : '0 0 0 2'
       }); 
       
       var rowVolume = Ext.create('Ext.container.Container', {
            defaultType : 'numberfield',
            items : [this.checkVolume, lblSetVolume, this.timeSpanVolume, lblSetVolume2],
            layout : 'column',
            margin : '5 0 5 10',
            width : 530
        });
        
       if(!this.dialogPreset) {
        /* REPEAT MUSIC */
         this.checkRepeat = Ext.create('Ext.form.field.Checkbox', {
                                        fieldLabel : "",
                                        align : 'middle',
                                        listeners:{
                                          'change': function(checkbox, newVal, oldVal){
                                             if (newVal > 0 && me.timeSpanRepeat.getValue() < 1)
                                               me.timeSpanRepeat.setValue(1);         
                                          }
                                        }                                      
                                      });

         var lblRepeat = Ext.create('Ext.form.Label',{
              text : _("Repeat music for maximum of"),
              align : 'middle',
              cls : 'x-form-item-label',
              margin : '0 0 0 10'
         }); 
         
         this.timeSpanRepeat  = Ext.create('Ext.form.field.Number', {
              fieldLabel : "",
              margin : '0 0 0 10',
              width : 50,
              step : 1,
              value : 0,
              minValue : 1,
              maxValue : 10
         });
         
         var lblRepeat2 = Ext.create('Ext.form.Label',{
              text : _("minutes"),
              align : 'middle',
              cls : 'x-form-item-label',
              margin : '0 0 0 5'
         }); 

         rowRepeat = Ext.create('Ext.container.Container', {
              defaultType : 'numberfield',
              items : [this.checkRepeat, lblRepeat, this.timeSpanRepeat, lblRepeat2],
              layout : 'column',
              margin : '5 0 5 10',
              width : 530
          });
          //rowRepeat.disable();
          
        
          /* RESTART MUSIC */
         this.checkRestart = Ext.create('Ext.form.field.Checkbox', {
                                        fieldLabel : "",
                                        align : 'right',
                                        listeners:{
                                          'change': function(checkbox, newVal, oldVal){
                                                     }
                                        }                                      
                                      });
                                      
         var lblRestart = Ext.create('Ext.form.Label',{
              text : _("Restart previous music once finished"),
              align : 'middle',
              cls : 'x-form-item-label',
              margin : '0 0 0 10'
         }); 
         
         var rowRestart = Ext.create('Ext.container.Container', {
              defaultType : 'numberfield',
              items : [this.checkRestart, lblRestart],
              layout : 'column',
              margin : '5 0 5 10',
              width : 530
          });
          //rowRestart.disable();
         
         /* GROUPING TEST */
         this.checkGrouping = Ext.create('Ext.form.field.Checkbox', {
                                        fieldLabel : "",
                                        align : 'left',
                                        listeners:{
                                          'change': function(checkbox, newVal, oldVal){
                                                     }
                                        }                                      
                                      });
                                      
         var lblGrouping = Ext.create('Ext.form.Label',{
              text : _("Group all players, if more than one (For testing only)"),
              align : 'middle',
              cls : 'x-form-item-label',
              margin : '0 0 0 10'
         }); 
         
         var rowGrouping = Ext.create('Ext.container.Container', {
              defaultType : 'numberfield',
              items : [this.checkGrouping, lblGrouping],
              layout : 'column',
              margin : '5 0 5 10',
              width : 530
          });
          rowGrouping.disable();
       }
                                    
      
       this.grids[this.parentDialog].pnlExtraFields = Ext.create('Ext.container.Container', {
           defaultType : 'numberfield',
           items : [  rowVolume, rowRepeat, rowRestart, rowGrouping ],
           layout: {type: 'vbox'},
           margin : '5 0 5 0',
           width : 600 });
     
       this.add(this.grids[this.parentDialog].pnlExtraFields);
}
catch (e){
   //alert("WtP constructActivityFields "+e.message);
}         
    },
    constructMacGrids : function() {
     // if (this.grids.lvl1==null) {
      this.grids[this.parentDialog].lvl1 = Ext.create('Ext.grid.Panel', {
             hideHeaders:true,
             height : this.iDefaultHeight,
             width : this.iDefaultWidth,
             autoScroll : true,
             viewConfig : {
                 stripeRows : true
             },
             selModel : {
                 mode : 'SINGLE'
             },
             store : Ext.data.StoreManager.lookup('whattoplay_l1Store_'+this.parentDialog),
             columns : [ {
                 sortable : false,
                 hideable : false,
                 dataIndex : 'name',
                 flex : 1,
                 renderer : this.defMacGridRenderer
             } ]
         });
      this.grids[this.parentDialog].lvl1.getSelectionModel().store = this.grids[this.parentDialog].lvl1.store;
      this.grids[this.parentDialog].lvl1.parent = this;
 
      this.grids[this.parentDialog].lvl1.on('itemclick', function(grid, record) {
             this.parent.nowFileType = -1;
             this.parent.macPanel.remove(this.parent.grids[this.parent.parentDialog].lvlNowRooms);
             this.parent.macPanel.remove(this.parent.grids[this.parent.parentDialog].lvlNowPlaying);
             this.parent.macPanel.remove(this.parent.grids[this.parent.parentDialog].lvlPlaylist);
             this.parent.macPanel.remove(this.parent.grids[this.parent.parentDialog].lvlFavorites);
             this.parent.macPanel.remove(this.parent.grids[this.parent.parentDialog].lvlCommands);
             
             var fIsPassive=false;
             if (record.get('passive')!=null) {
                 if (record.get('passive')==true) {
                     this.getSelectionModel().deselect(record);
                     fIsPassive=true;
                 }
             }
             if (!fIsPassive) {
                 if (record.get('_id') == 0) { // nowPlaying
                     this.parent.constructGridLvlNowPlaying();
                     this.getSelectionModel().deselectAll();
                     this.getSelectionModel().select(record);
                 }
                 else if (record.get('_id') == 1) { // playlist
                     this.parent.constructGridLvlPlaylist();
                     this.getSelectionModel().deselectAll();
                     this.getSelectionModel().select(record);
                 }
                 else if (record.get('_id') == 2) { // favorites
                     this.parent.constructGridLvlFavorites();
                     this.getSelectionModel().deselectAll();
                     this.getSelectionModel().select(record);
                 }
                 else if (record.get('_id') == 5) { // commands
                     this.parent.constructGridLvlCommands();
                     this.getSelectionModel().deselectAll();
                     this.getSelectionModel().select(record);
                 }
                 
             }
         }); 
      if(!this.macPanel.contains(this.grids[this.parentDialog].lvl1, true))
        this.macPanel.add(this.grids[this.parentDialog].lvl1);
     // }
    },
    constructor : function(config) {
       if(config.parent == 'Preset')
       {
         this.dialogPreset = true;
         this.parentDialog = 'preset';
         this.iDefaultHeight = 290;
       } 
       else {
         this.dialogPreset = false;
         this.parentDialog = 'activity';
         this.iDefaultHeight = 220;
       }
       this.macPanel = Ext.create('Ext.panel.Panel', {
              border : '0',
              autoScroll : true,
              height : this.iDefaultHeight+2,
              layout : {
                  type : 'hbox'
              },
              items : [  ],//this.grids.lvl1
              scroll : 'horizontal'
          });
          Ext.apply(this, {
              items : [ this.macPanel]
          });

         this.callParent(arguments);
    },
    clearGridLevels : function() {
      if (this.grids[this.parentDialog].lvl1 != null) {
         this.macPanel.remove(this.grids[this.parentDialog].lvl1);
      }
      if (this.grids[this.parentDialog].lvlNowPlaying != null) {
         this.macPanel.remove(this.grids[this.parentDialog].lvlNowRooms); 
         this.macPanel.remove(this.grids[this.parentDialog].lvlNowPlaying); 
      }
      if (this.grids[this.parentDialog].lvlPlaylist != null) {
         this.macPanel.remove(this.grids[this.parentDialog].lvlPlaylist); 
      }
      if (this.grids[this.parentDialog].lvlFavorites != null) {
        this.macPanel.remove(this.grids[this.parentDialog].lvlFavorites); 
      }
      if (this.grids[this.parentDialog].lvlCommands != null) {
        this.macPanel.remove(this.grids[this.parentDialog].lvlCommands);
      }
      if (this.grids[this.parentDialog].pnlExtraFields != null) {
         this.remove(this.grids[this.parentDialog].pnlExtraFields);
      }
    },
    reset : function() {
try {
      this.clearGridLevels();
      this.nowFileType = -1;
      
      this.initStores();
      this.constructMacGrids();
      
      this.checkVolume.setValue(false); 
      this.timeSpanVolume.setValue(0);
      if (!this.dialogPreset) {
        this.checkRepeat.setValue(false); 
        this.timeSpanRepeat.setValue(0);
        this.checkRestart.setValue(false); 
        this.checkGrouping.setValue(false); 
      }
      this.grids[this.parentDialog].lvl1.getSelectionModel().deselectAll();
}
catch (e){
   //alert("WtP reset "+e.message);
}      
    },
    setValue : function(values) {
      try {
        this.clearGridLevels();
        this.nowFileType = -1;

        this.initStores();
        this.constructMacGrids();
        
        this.checkVolume.setValue(false); 
        this.timeSpanVolume.setValue(0);
        if (!this.dialogPreset) {
          this.checkRepeat.setValue(false); 
          this.timeSpanRepeat.setValue(0);
          this.checkRestart.setValue(false); 
          this.checkGrouping.setValue(false); 
        }
        
        var nSelectedID = this.dssEditor.editControls.id.getValue();
        if (nSelectedID != null) { // edit existing dialog
          
          if (this.dialogPreset) {
            var sString = dss.ajaxSyncRequest('/json/property/query', {
                                              'query' : '/scripts/sonos-controller/sonos-presets/'+nSelectedID+'(*)'
                                            });
            var result = Ext.JSON.decode(sString);
            var arrayData = dss.parsePropertyQueryAnswer(result,[{name:'actionType',type:'simple'},
                                                                 {name:'playListSonosID', type:'simple'},
                                                                 {name:'favoritesSonosID', type:'simple'},
                                                                 {name:'nowAction', type:'simple'},
                                                                 {name:'nowSingleTitle', type:'simple'},
                                                                 {name:'nowSingleIsRadio', type:'simple'},
                                                                 {name:'nowSingleArtist', type:'simple'},
                                                                 {name:'command', type:'simple'},
                                                                 {name:'volumeSet', type:'simple'},
                                                                 {name:'volume', type:'simple'}]); 
          }
          else {
            var sString = dss.ajaxSyncRequest('/json/property/query', {
                                              'query' : '/scripts/sonos-controller/sonos-activities/'+nSelectedID+'(*)'
                                            });
            var result = Ext.JSON.decode(sString);
            var arrayData = dss.parsePropertyQueryAnswer(result,[{name:'actionType',type:'simple'},
                                                                 {name:'playListSonosID', type:'simple'},
                                                                 {name:'favoritesSonosID', type:'simple'},
                                                                 {name:'nowAction', type:'simple'},
                                                                 {name:'volumeSet', type:'simple'},
                                                                 {name:'volume', type:'simple'},
                                                                 {name:'setRepeat', type:'simple'},
                                                                 {name:'repeatTime', type:'simple'},
                                                                 {name:'restartAfter', type:'simple'},
                                                                 {name:'createSonosGroup', type:'simple'},
                                                                 {name:'nowSingleTitle', type:'simple'},
                                                                 {name:'nowSingleIsRadio', type:'simple'},
                                                                 {name:'nowSingleArtist', type:'simple'},
                                                                 {name:'command', type:'simple'}]); 
          }
          
          if (arrayData != null) {
            var sceneData = arrayData[0];
           
            var nActionType = parseInt("" + sceneData.actionType,10);
           
            var oRecordZone = this.grids[this.parentDialog].lvl1.store.find('_id',sceneData.actionType,false,false,true);
            this.grids[this.parentDialog].lvl1.getSelectionModel().select(oRecordZone,true);  
            switch(nActionType) {
              case 0:
                this.constructGridLvlNowPlaying();
                
                if (!this.dialogPreset) {
                  this.grids[this.parentDialog].lvlNowRooms.getSelectionModel().select(0)
                  this.macPanel.add(this.grids[this.parentDialog].lvlNowPlaying);
                }
                
                this.lblNowPlayed.setVisible(false);
                this.gridQueue.setVisible(false);
                
                this.nowFileType = parseInt("" + sceneData.nowAction,10);
                var sTitle = "";
                if (this.nowFileType == 0) { // single song/radio
                  if (sceneData.nowSingleTitle != "") {
                    sTitle = _("Song: ");
                    if (JSON.parse(sceneData.nowSingleIsRadio))
                      sTitle = _("Radio: ");
                          
                    if (sceneData.nowSingleTitle != "")
                      sTitle += sceneData.nowSingleTitle;
                    if (sceneData.nowSingleArtist != "")
                      sTitle += " ("+sceneData.nowSingleArtist+")";
                    this.selectedSong = new Object({changed:false});
                  }                
                  this.lblNowPlayed.setText(unescape(sTitle));               
                  this.lblNowPlayed.setVisible(true);
                }
                else { // Active queue
                  var sPath = "sonos-presets";
                  if (!this.dialogPreset)
                    sPath = "sonos-activities";
                  sString = dss.ajaxSyncRequest('/json/property/query', {
                       'query' : '/scripts/sonos-controller/'+sPath+'/'+nSelectedID+'/active-queue/*(*)/*(*)/*(*)/*(*)'
                   });            
                  var result = Ext.JSON.decode(sString);
                  var arrayQueue = dss.parsePropertyQueryAnswer(result,[{name:'id', type:'simple'},
                                                                        {name:'title', type:'simple'},
                                                                        {name:'artist',type:'simple'}]); 
                  if (arrayQueue != null && arrayQueue.length > 0) {
                    var arrayFiles  = new Array();
                    for ( var iIndex = 0; iIndex < arrayQueue.length; iIndex++) {
                      arrayFiles.push(new Object({'_id':iIndex, 'name':unescape((iIndex+1)+". "+arrayQueue[iIndex].title)}));
                    }
                    Ext.data.StoreManager.lookup('whattoplay_queue').add(arrayFiles);  
                    this.gridQueue.setVisible(true);
                    this.selectedQueue = new Object({changed:false});
                  }
                }
              break;
             
              case 1:
                this.constructGridLvlPlaylist();
                var oRecordZone = this.grids[this.parentDialog].lvlPlaylist.store.find('_id', unescape(sceneData.playListSonosID), 0, false,false,true);
                if (oRecordZone != -1)
                  this.grids[this.parentDialog].lvlPlaylist.getSelectionModel().select(oRecordZone);
              break;
              
              case 2:
                this.constructGridLvlFavorites();
                var oRecordZone = this.grids[this.parentDialog].lvlFavorites.store.find('_id', unescape(sceneData.favoritesSonosID), 0, false,false,true);
                if (oRecordZone != -1)
                  this.grids[this.parentDialog].lvlFavorites.getSelectionModel().select(oRecordZone);
              break;
              
              case 5:
                this.constructGridLvlCommands();
                var oRecordZone = this.grids[this.parentDialog].lvlCommands.store.find('_id', unescape(sceneData.command), 0, false,false,true);
                if (oRecordZone != -1)
                  this.grids[this.parentDialog].lvlCommands.getSelectionModel().select(oRecordZone);
              break;
            }
            
            if (JSON.parse(sceneData.volumeSet)) {
              this.checkVolume.setValue(true);
              this.timeSpanVolume.setValue(sceneData.volume);
            }
            if (!this.dialogPreset) {
              if (JSON.parse(sceneData.setRepeat)) {
                this.checkRepeat.setValue(true);
                this.timeSpanRepeat.setValue(sceneData.repeatTime);
              }

              if (JSON.parse(sceneData.restartAfter)) 
                this.checkRestart.setValue(true);

              if (JSON.parse(sceneData.createSonosGroup)) 
                this.checkGrouping.setValue(true);
            }
          }
        }
      }
      catch (e){
alert("WtP setValue "+e.message);
      }
    },
    isValid : function() {
       var bValid = false;
       var bIsSingleFile = false; 
     
       var oSelectionLVL1 = this.grids[this.parentDialog].lvl1.getSelectionModel().getSelection();
       if (oSelectionLVL1[0] != null) {
         switch(oSelectionLVL1[0].get('_id')) {
           case 0:
            if (this.nowFileType == 0 && this.selectedSong != null) {
              bValid = true; 
              bIsSingleFile = true; 
            }
            else  
              if (this.nowFileType == 1 && this.selectedQueue != null) 
                bValid = true; 
           break; 
           
           case 1: // playlists
             oSelectionPlaylist = this.grids[this.parentDialog].lvlPlaylist.getSelectionModel().getSelection();
             if (oSelectionPlaylist != null && oSelectionPlaylist.length > 0) {
               bValid = true; 
             }
           break; 

           case 2: // favorites
             
             oSelectionFavorites = this.grids[this.parentDialog].lvlFavorites.getSelectionModel().getSelection();
             if (oSelectionFavorites != null && oSelectionFavorites.length > 0) {
               bValid = true; 
               // check if single file
               if (!this.dialogPreset)
                 bIsSingleFile = (oSelectionFavorites[0].get('name').indexOf(".mp3") > -1);
             }
           break; 

           case 5: // command
             oSelectionCommand = this.grids[this.parentDialog].lvlCommands.getSelectionModel().getSelection();
             if (oSelectionCommand != null && oSelectionCommand.length > 0) {
               bValid = true; 
             }
           break; 
         }
       }
       
       if (!this.dialogPreset) {
         if (this.checkRepeat.checked && this.timeSpanRepeat.getValue() < 1) {
           Ext.MessageBox.alert(_('Info'), _("Repeated time in minutes is missing!"), null);
           bValid = false;
         }
        
         if (bValid && this.checkRestart.checked && !this.checkRepeat.checked && !bIsSingleFile) {
           if (this.dssEditor.editControls.triggers != null && 
               this.dssEditor.editControls.triggers.getValue().length>0 &&
               (                                                                                    
                (this.dssEditor.editControls.triggers.getValue()[0].type != 'zone-scene') ||
                 (
                  this.dssEditor.editControls.triggers.getValue()[0].type == 'zone-scene' && 
                  predefinedUnduEvents.indexOf(this.dssEditor.editControls.triggers.getValue()[0].scene) == -1
                 )
               )) {
                 Ext.MessageBox.alert(_('Info'), _("Uknown execution length. You must select option 'Repeat music for maximum of x minutes'!"), null);
                 bValid = false;
             }
         }
       }
       
       return bValid;
    },
    getValue : function() {
      var returnValue = new Object();
      try {
        var oSelectionLVL1 = this.grids[this.parentDialog].lvl1.getSelectionModel().getSelection();
        for ( var iIndex = 0; iIndex < oSelectionLVL1.length; iIndex++) {       
          if (oSelectionLVL1[iIndex].get('_id') == 0) { // nowPlaying
            var sSong = "";
            if (this.nowFileType == 0) // single track
              sSong = this.selectedSong
            else  // Active queue
              // problem when sending long data over url- on save we get 413 request entity too large
              // So in this case we store data temporary to PropertyTree(on button ""get queue"" click), and on saving we gaet queue from PT
              if (this.selectedQueue.changed)
                sSong = new Object({changed:true});

            returnValue.actionType = 0;
            returnValue.nowAction = this.nowFileType;
            returnValue.selectedData = sSong;
          }
          else
          if (oSelectionLVL1[iIndex].get('_id') == 1) { // playlist
            var oSelectionPlaylist = this.grids[this.parentDialog].lvlPlaylist.getSelectionModel().getSelection();
            returnValue.actionType = 1;
            returnValue.playListSonosID = oSelectionPlaylist[0].get('_id');
            returnValue.listUrl = oSelectionPlaylist[0].get('listUrl');
            returnValue.title = oSelectionPlaylist[0].get('name');
          }
          else
          if (oSelectionLVL1[iIndex].get('_id') == 2) { // favorites
            var oSelectionFavorites = this.grids[this.parentDialog].lvlFavorites.getSelectionModel().getSelection();
            returnValue.actionType = 2;
            returnValue.playListSonosID = oSelectionFavorites[0].get('_id');
            returnValue.listUrl = oSelectionFavorites[0].get('listUrl');
            returnValue.title = oSelectionFavorites[0].get('name');
          }
          else
          if (oSelectionLVL1[iIndex].get('_id') == 5) { // Command
            var oSelectionCommand = this.grids[this.parentDialog].lvlCommands.getSelectionModel().getSelection();
            returnValue.actionType = 5;
            returnValue.command = oSelectionCommand[0].get('_id');
          }
        }
        
        returnValue.setVolume = this.checkVolume.checked;
        returnValue.volume = this.timeSpanVolume.getValue(); 
        if (!this.dialogPreset) {
          // activity dialog, extra fields at bottom of grid
          returnValue.setRepeat = this.checkRepeat.checked;
          returnValue.repeatTime = this.timeSpanRepeat.getValue(); 
          returnValue.restartAfter = this.checkRestart.checked;
          returnValue.createSonosGroup = this.checkGrouping.checked;
        } 
      }
      catch (e){
//alert("WtP getValue "+e.message);
      }
      
      this.clearGridLevels();

      return returnValue;
    }    
});

Ext.define('DSS.addon.SelectRooms', {
    extend : 'DSS.component.Base',
    mixins : {
        observable : 'Ext.util.Observable'
    },
    getHeight:function () {
                 return 20;
    },
    nSelectedAction:-1,
    actionRoomsPanel:null,
    actionRoomsPanelMulti:null,
    actionTypeAll:null,
    lblActionRooms:null,
    rowExecRooms:null,
    gridRooms:null,
    roomRenderer : function(val, metadata, record, colIdx, store, view) {
       var sPassive="";        
       if (record.get('passive')!=null && record.get('passive'))
         sPassive='style="color:#888888;"';
       var sReturn='<table style="height:16px;"><tr>';
       sReturn+='<td '+sPassive+' width="100%">' + record.get('roomName') + '</td>';
       return sReturn +'</tr></table>';      
    },
    constructor : function(config) {
         var me = this;             
         this.lblActionRooms  = Ext.create('Ext.form.Label',{
              text : _("Play music in:"),
              align : 'middle',
              cls : 'x-form-item-label',
              margin : '0 0 0 0'
         }); 

         this.actionTypeAll = Ext.create('Ext.form.RadioGroup', {
            fieldLabel : _(''),
            labelWidth : 340,
            items : [ {
                inputValue : 0,
                boxLabel : _('All rooms'),
                name : 'roomType'} ],
            columns : 1,
            columnWidth:400,
            width:400,
            padding : '0 0 2 0',
            listeners: {
              change: function(radiogroup, radio) {
                 if (radio.roomType != null) {
                   me.nSelectedAction = 0;
                   me.gridRooms.disable();
                   me.gridRooms.getSelectionModel().deselectAll();
                 }
              }
            }
         }); 

         this.actionTypeMulti = Ext.create('Ext.form.RadioGroup', {
            fieldLabel : _(''),
            labelWidth : 340,
            items : [ {
                inputValue : 1,
                boxLabel : _('Selected rooms'),
                name : 'roomType'} ],
            columns : 1,
            columnWidth:400,
            width:400,
            padding : '0 0 4 0',
            listeners: {
              change: function(radiogroup, radio) {
                 if (radio.roomType != null) {
                   me.nSelectedAction = 1;
                   me.gridRooms.enable();
                   me.gridRooms.getSelectionModel().deselectAll();
                 }
              }
            }
         }); 
     
         this.gridRooms = Ext.create('Ext.grid.Panel', {
             hideHeaders:true,
             autoScroll : true,
             width:300,
             height:280,
             margin : '0 0 0 20',
             viewConfig : {
                 stripeRows : true
             },
             selModel : {
                 mode : 'MULTI'
             },
             columns : [ {
                 sortable : false,
                 hideable : false,
                 dataIndex : 'roomID',
                 flex : 1,
                 renderer : this.roomRenderer
             } ]
         }); 
         

         this.actionRoomsPanel = Ext.create('Ext.container.Container', {
              defaultType : 'numberfield',
              items : [  this.actionTypeAll, this.actionTypeMulti, this.gridRooms],
              layout: {type: 'vbox'},
              margin : '0 0 0 10',
              width : 400
         });
         
         
         this.rowExecRooms = Ext.create('Ext.container.Container', {
              defaultType : 'numberfield',
              items : [this.lblActionRooms, this.actionRoomsPanel],
              layout : 'column',
              margin : '0 0 0 10',
              width : 530
          });
        Ext.apply(this, {
            items : [this.rowExecRooms]// 
        });                          
        this.callParent(arguments);
    },
    reset: function (){
try{      
      this.gridRooms.reconfigure(Ext.data.StoreManager.lookup('whattoselect_rooms'));
      this.actionTypeAll.setValue({'roomType':0});
      this.gridRooms.disable();
      this.gridRooms.getSelectionModel().deselectAll();
}
catch (e){
   //alert("SelectRooms reset "+e.message);
}
    },
    setValue:function (value){
     try{ 
      this.gridRooms.reconfigure(Ext.data.StoreManager.lookup('whattoselect_rooms'));
      this.gridRooms.getSelectionModel().deselectAll();
      this.gridRooms.disable();
      this.actionTypeAll.setValue({'roomType':0});
      var sString = dss.ajaxSyncRequest('/json/property/query', {
                                        'query' : '/scripts/sonos-controller/sonos-activities/'+this.dssEditor.editControls.id.getValue()+'(*)'
                                      });
      var result = Ext.JSON.decode(sString);
      var arrayData = dss.parsePropertyQueryAnswer(result,[{name:'allRooms',type:'simple'},
                                                           {name:'pickedRooms', type:'simple'}]); 
      if (arrayData != null) {
        var bAllRooms = JSON.parse(arrayData[0].allRooms);
        this.nSelectedAction = 0;
        if (!bAllRooms) {
          this.nSelectedAction = 1;
          this.gridRooms.enable();
          this.actionTypeAll.setValue({'roomType':1});
         
          var rooms = unescape(arrayData[0].pickedRooms).split(";");
          var missingRooms = new Array();
          var selected = new Array();
          var store = this.gridRooms.getStore();
          for ( var iIndex = 0; iIndex < rooms.length; iIndex++) {
            var foundRec = store.getAt(store.findExact('roomID', rooms[iIndex]));
            if (foundRec != null)
              selected.push(foundRec);
            else
              if (parseInt("" + rooms[iIndex],10) > 0)
                missingRooms.push(rooms[iIndex]);
          }
          
          if (missingRooms.length == 0) {
            this.gridRooms.getSelectionModel().select(selected);
          } 
          else {
            // we must add missing rooms to list
            for ( var iIndex = 0; iIndex < missingRooms.length; iIndex++) {
              for ( var yIndex = 0; yIndex < dss.staticDataModel.nameCache.length; yIndex++) {
                if (missingRooms[iIndex] == dss.staticDataModel.nameCache[yIndex].ZoneID) {  
                  store.insert(store.getCount, new Object({'roomName': dss.staticDataModel.nameCache[yIndex].name,
                                              'roomID' : missingRooms[iIndex],
                                              'passive' : true }));
                }
              }
            }  
            selected = [];
            for (var iIndex = 0; iIndex < rooms.length; iIndex++) {
              var foundRec = store.getAt(store.findExact('roomID', rooms[iIndex]));
              if (foundRec != null)
                selected.push(foundRec);
            }
            this.gridRooms.getSelectionModel().select(selected);
          }
        }
      }
     }
     catch (e){
   //alert("SelectRooms setValue"+e.message);
     }
    },
    isValid:function(){
       var bValid = false;
       if (this.nSelectedAction == 0)
         bValid = true;
       else
         if (this.nSelectedAction == 1) 
           bValid = (this.gridRooms.getSelectionModel().getSelection().length > 0);
     
       return bValid;
    },
    getValue : function(){
      var returnValue = new Object();
      
      returnValue.action = this.nSelectedAction;
      if (this.nSelectedAction == 1) { // selected rooms
        var oSelectionRooms = this.gridRooms.getSelectionModel().getSelection();
        if (oSelectionRooms.length > 0) {
          returnValue.rooms = new Array();
          for ( var iIndex = 0; iIndex < oSelectionRooms.length; iIndex++) {       
            returnValue.rooms.push(parseInt("" + oSelectionRooms[iIndex].get('roomID'), 10));
          }
        }
      }
      
      return returnValue;
    }
});

